"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    default: ()=>_default,
    CounterComponentExample: ()=>CounterComponentExample
});
const _index = require("../index");
const _util = require("./util");
const _default = {
    title: 'Example/custom-components'
};
const customButton = (0, _index.defineComp)(CustomButton);
const counterComponent = (0, _index.defineComp)(CounterComponent);
const template = (0, _util.createTemplate)(counterComponent);
const CounterComponentExample = template({});
function CustomButton(props) {
    const { x , y , width , height  } = props;
    const [state, setState] = (0, _index.crcState)('idle');
    const fillStyle = state === 'idle' ? 'gray' : 'blue';
    const lineWidth = 2;
    const strokeStyle = state === 'idle' ? 'black' : 'white';
    return [
        (0, _index.rect)({
            x,
            y,
            width,
            height,
            fillStyle,
            lineWidth,
            strokeStyle,
            cursor: 'pointer',
            onClick: props.onClick,
            onMouseOver: ()=>setState('hover'),
            onMouseOut: ()=>setState('idle')
        }),
        (0, _index.text)({
            x: x + width / 2,
            y: y + height / 2,
            text: props.label,
            textAlign: 'center',
            textBaseline: 'middle',
            fillStyle: strokeStyle,
            font: '20px Arial'
        })
    ];
}
function CounterComponent() {
    const [count, setCount] = (0, _index.crcState)(0);
    return customButton({
        x: 10,
        y: 10,
        width: 100,
        height: 40,
        label: count.toString(),
        onClick: ()=>{
            setCount((c)=>c + 1);
        }
    });
}

//# sourceMappingURL=custom-components.stories.js.map